package edu.tum.xmts.junit;

import static org.junit.Assert.assertEquals;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.StringReader;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import edu.tum.xmts.TransitionSystem;
import edu.tum.xmts.utils.XMTSReader;
import edu.tum.xmts.utils.XMTSWriter;

public class XMTSWriterTest {

	private final String DIR = "../xmts-specification/examples";

	@SuppressWarnings("null")
	public void testWriteTransitionSystem() throws Exception {
		XMTSReader reader = new XMTSReader();
		XMTSWriter writer = new XMTSWriter();

		List<File> files = new LinkedList<>();

		files.addAll(Arrays.asList(new File(DIR + "/traffic").listFiles((d, s) -> s.endsWith(".xmts"))));
		files.addAll(Arrays.asList(new File(DIR + "/coffee and tea").listFiles((d, s) -> s.endsWith(".xmts"))));
		files.addAll(Arrays.asList(new File(DIR).listFiles((d, s) -> s.endsWith(".xmts"))));

		for (File xmtsFile : files) {
			TransitionSystem system = reader.read(xmtsFile);
			String systemString = writer.write(system);

			reader.read(writer.write(system));
			assertEqual(xmtsFile, systemString);
		}
	}

	private static void assertEqual(File file, String string) throws Exception {
		try (BufferedReader reader1 = new BufferedReader(new FileReader(file))) {
			BufferedReader reader2 = new BufferedReader(new StringReader(string));

			String line1, line2;

			do {
				line1 = reader1.readLine();
				line2 = reader2.readLine();
				assertEquals(file.getPath() + ": <" + line1 + "> expected, but <" + line2 + ">", line1, line2);
			} while (line1 != null || line2 != null);
		}
	}
}
